ClassDescription subclass:#JavaClass
	instanceVariableNames:'fullName accessFlags constantPool sourceFile fields'
	classVariableNames:''
	poolDictionaries:''
	category:'Java-Classes'
!


!JavaClass class methodsFor:'instance creation'!

fullName:aString
    ^ self new setFullName:aString

    "Created: 15.4.1996 / 15:52:55 / cg"
!

name:aString
    self shouldNotImplement

    "Created: 15.4.1996 / 15:52:55 / cg"
! !

!JavaClass methodsFor:'accessing'!

category
    "java classes do not really hav a category;
     simulate one by separating its name into individual components,
     prepending 'java'"

    |nameComponents|

    nameComponents := fullName asCollectionOfSubstringsSeparatedBy:$/.
    ^ 'java-' , (nameComponents asStringWith:$/ from:1 to:(nameComponents size - 1))
!

constantPool
    ^ constantPool
!

fullName
    ^ fullName
!

name
    ^ name "/ fullName
!

package
    "extract from the fullName"

    |components|

    components := fullName asCollectionOfSubstringsSeparatedBy:$/.
    components size > 1 ifTrue:[
        ^ (components copyWithoutLast:1) asStringWith:$/
    ].
    ^ fullName

    "
     Java allClasses first fullName
     Java allClasses first package  
    "
!

sourceFile
    ^ sourceFile
! !

!JavaClass methodsFor:'instance creation'!

basicNew
    |newJavaObject|

    newJavaObject := super basicNew.
    newJavaObject initializeToZero.     "/ mhmh
    ^ newJavaObject
!

new
    |newJavaObject|

    newJavaObject := self basicNew.
    newJavaObject invoke:#'<init>'.
    ^ newJavaObject


! !

!JavaClass methodsFor:'printing & storing'!

displayString
    ^ 'JAVA-' , name .
    ^ name , '(Java)'  "/ 'JavaClass(' , name , ')'

    "Created: 15.4.1996 / 16:02:48 / cg"
! !

!JavaClass methodsFor:'private accessing'!

addMethod:m name:name signature:signature
    selectorArray isNil ifTrue:[
        selectorArray := #().
        methodArray := #()
    ].
    selectorArray := selectorArray copyWith:(name , signature) asSymbol. "/ name.
"/    selectorArray := selectorArray copyWith:name asSymbol. "/ name.
    methodArray := methodArray copyWith:m

    "Created: 15.4.1996 / 16:42:52 / cg"
!

setAccessFlags:flags
    accessFlags := flags.

    "Created: 15.4.1996 / 16:42:52 / cg"
!

setConstantPool:anArray
    constantPool := anArray.

    "Created: 15.4.1996 / 16:42:52 / cg"
!

setFields:f
    |varNames|

    varNames := ''.
    f do:[:aField |
        varNames := varNames , aField name , ' '
    ].
    instvars := varNames.
"/    instSize := superclass instSize + f size.

    fields := f

    "Created: 15.4.1996 / 16:42:52 / cg"
!

setFullName:aString
    |nameComponents|

    fullName := aString.
    nameComponents := aString asCollectionOfSubstringsSeparatedBy:$/.
    name := nameComponents last

    "Created: 15.4.1996 / 16:42:52 / cg"
!

setSourceFile:aFilename
    sourceFile := aFilename.

    "Created: 15.4.1996 / 16:42:52 / cg"
!

setSuperclass:aClass
    aClass isNil ifTrue:[
        super setSuperclass:JavaObject
    ] ifFalse:[
        (aClass isMemberOf:JavaUnresolvedClassConstant) ifTrue:[
            self halt.
        ].
        super setSuperclass:aClass.
    ].

    instvars notNil ifTrue:[
        (superclass notNil and:[(superclass isMemberOf:JavaUnresolvedClassConstant) not]) ifTrue:[
            instSize := superclass instSize + (instvars asCollectionOfWords size)
        ] ifFalse:[
            instSize := instvars asCollectionOfWords size
        ]
    ].

    "Created: 15.4.1996 / 16:42:52 / cg"
! !

!JavaClass methodsFor:'queries'!

isClass
    ^ true
!

isFinal
    ^ (accessFlags bitAnd:16r0010) ~~ 0
!

isInterface
    ^ (accessFlags bitAnd:16r0200) ~~ 0
!

isPublic
    ^ (accessFlags bitAnd:16r0001) ~~ 0


! !

!JavaClass methodsFor:'resolving class refs'!

resolveClassRefs
    |newClass const newConst|

    (superclass isMemberOf:JavaUnresolvedClassConstant) ifTrue:[
        newClass := superclass resolve.
        newClass isNil ifTrue:[
            newClass := JavaClassReader loadClass:(superclass fullName).
        ].
        newClass notNil ifTrue:[
            superclass := newClass
        ]
    ].

    1 to:constantPool size do:[:index |
        const := constantPool at:index.
        (const isMemberOf:JavaUnresolvedClassConstant) ifTrue:[
            "/ try to resolve
            newConst := const resolve.
            newConst isNil ifTrue:[
                newConst := JavaClassReader loadClass:(const fullName).
            ].
            newConst notNil ifTrue:[
                constantPool at:index put:newConst
            ]
        ]
    ].

    (superclass notNil and:[(superclass isMemberOf:JavaUnresolvedClassConstant) not]) ifTrue:[
        superclass resolveClassRefs.
        instSize := superclass instSize + (instvars asCollectionOfWords size)
    ] ifFalse:[
        instSize := instvars asCollectionOfWords size
    ].
Transcript show:'resolved '; show: self displayString; 
           show: ' instSize='; showCr:  instSize.
! !

!JavaClass class methodsFor:'documentation'!

version
    ^ '$Header: /home/jv/Projects/SmalltalkX/repositories/cvs/stx/libjava/JavaClass.st,v 1.12 1996/05/02 17:08:54 cg Exp $'
! !
